;this demo illustrates texture mapping

;we'll use this alias when speed is not an issue
alias -l gl { var %c = $dll(nLIGHTn,gl,$1-) | if (E_* iswm %c) echo -s %c }

;this alias convert textures from .jpg to .bmp format
alias -l jpg2bmp {
  window -hpf @jpg2bmp1 0 0 128 128 | window -hpf @jpg2bmp2 0 0 256 256
  drawpic @jpg2bmp1 0 0 $+(",$scriptdirchecker1.jpg,") | drawsave -b24 @jpg2bmp1 $+(",$scriptdirchecker1.bmp,")
  drawpic @jpg2bmp2 0 0 $+(",$scriptdirmarblewhite.jpg,") | drawsave -b24 @jpg2bmp2 $+(",$scriptdirmarblewhite.bmp,")
  close -@ @jpg2bmp1 @jpg2bmp2
}

;run this alias to see the demo
alias gldemo {

  ;first, we create a picture window... will work for dialog controls as well
  window -p @test -1 -1 400 200
  window -r @test
  titlebar @test - Press any key to toggle fog

  ;attach a rendering device to the window
  gl attach $window(@test).hwnd

  ;set scaling mode 1 ('retain proportions'), viewing angle 45, near and far clipping planes
  gl auto_scale 1 45 1 40
  gl enable cull_face
  gl fog fog_mode exp2
  gl fog fog_color 0.6 0.6 0.6

  ;load textures
  if !$isfile($scriptdirchecker1.bmp) { jpg2bmp }
  gl enable texture_2d
  gl bind_texture 1
  gl load_texture $scriptdirchecker1.bmp
  gl bind_texture 2
  gl load_texture $scriptdirmarblewhite.bmp

  ;compile a rendering sequence (display list) for the front side of our cube
  gl new_list 1000  
  gl begin quads
  gl tex_coord 0 0 | gl vertex -1 -1 1
  gl tex_coord 1 0 | gl vertex 1 -1 1
  gl tex_coord 1 1 | gl vertex 1 1 1
  gl tex_coord 0 1 | gl vertex -1 1 1
  gl end
  gl end_list

  ;let's make a display list for the floor
  gl new_list 1002
  gl fog fog_density 0.008
  gl bind_texture 2
  gl color 0.4 0.8 0.4
  gl begin quads
  gl tex_coord 0 0   | gl vertex -400 -3 200
  gl tex_coord 50 0  | gl vertex 400 -3 200
  gl tex_coord 50 25 | gl vertex 400 -3 -200
  gl tex_coord 0 25  | gl vertex -400 -3 -200
  gl end
  gl color 1 1 1
  gl end_list

  ;list 1001 will be our cube
  ;we simply repeat list 1000 with different rotations (yes, lists can be nested)
  gl new_list 1001
  gl fog fog_density 0.15  
  gl bind_texture 1
  ;front
  gl call_list 1000
  ;left
  gl rotate 90 0 1 0
  gl call_list 1000
  ;back
  gl rotate 90 0 1 0
  gl call_list 1000
  ;right
  gl rotate 90 0 1 0
  gl call_list 1000
  ;top
  gl rotate 90 0 1 0
  gl rotate 90 1 0 0
  gl call_list 1000
  ;bottom
  gl rotate 180 1 0 0
  gl call_list 1000
  gl end_list

  ;start rendering
  .timergl -m 0 1 gl_paint attach $window(@test).hwnd
}

;this is where we render graphics
;we don't use the 'gl' alias as it slows mIRC down

alias gl_paint {
  var %s = $sin($calc($ticks / 3000)), %c = $cos($calc($ticks / 3000))
  dll nLIGHTn gl $1- 
  dll nLIGHTn gl clear 
  dll nLIGHTn gl load_identity 
  dll nLIGHTn gl look_at 0 0 $calc(10 + 4 * %s) 0 0 0 0 1 0
  dll nLIGHTn gl push_matrix 
  dll nLIGHTn gl translate $calc(50 * %c) 0 $calc(50 * %s) 

  dll nLIGHTn gl call_list 1002
  dll nLIGHTn gl pop_matrix 
  dll nLIGHTn gl rotate 160 %s %c $sin(%c) 

  dll nLIGHTn gl call_list 1001 
  dll nLIGHTn gl swap_buffers
}

;when the window gets closed, the timer should stop
on *:close:@test: .timergl off

;we toggle for upon keypress
on *:KEYDOWN:@test:*: {
  gl attach $window(@test).hwnd
  if $dll(nLIGHTn,gl,is_enabled fog) { gl disable fog | gl clear_color }
  else { gl enable fog | gl clear_color 0.6 0.6 0.6 }
}

;cleanup
on *:UNLOAD: {
  .remove $+(",$scriptdirchecker1.bmp,")
  .remove $+(",$scriptdirmarblewhite.bmp,")
}
