;simple skybox technique

;this alias convert textures from .jpg to .bmp format
alias -l jpg2bmp {
  window -hpf @jpg2bmp 0 0 512 512
  drawpic @jpg2bmp 0 0 $+(",$scriptdirdfront.jpg,") | drawsave -b24 @jpg2bmp $+(",$scriptdirfront.bmp,")
  drawpic @jpg2bmp 0 0 $+(",$scriptdirdleft.jpg,")  | drawsave -b24 @jpg2bmp $+(",$scriptdirleft.bmp,")
  drawpic @jpg2bmp 0 0 $+(",$scriptdirdback.jpg,")  | drawsave -b24 @jpg2bmp $+(",$scriptdirback.bmp,")
  drawpic @jpg2bmp 0 0 $+(",$scriptdirdright.jpg,") | drawsave -b24 @jpg2bmp $+(",$scriptdirright.bmp,")
  drawpic @jpg2bmp 0 0 $+(",$scriptdirdup.jpg,")    | drawsave -b24 @jpg2bmp $+(",$scriptdirtop.bmp,")
  drawpic @jpg2bmp 0 0 $+(",$scriptdirddown.jpg,")  | drawsave -b24 @jpg2bmp $+(",$scriptdirbottom.bmp,")
  close -@ @jpg2bmp
}

;a temporary alias for simplifying nLIGHTn calls
alias gl { var %c = $dll(nLIGHTn,gl,$1-) | if (E_* iswm %c) echo -a $1- : %c | return %c }

;call this alias to see the demo
alias gldemo {
  clear

  ;create a picture window (any HWND will do)
  window -p @test 0 0 512 256
  window -r @test
  titlebar @test - Use your mouse to look around

  ;attach a rendering device to the window and make it current
  gl attach $window(@test).hwnd

  ;convert textures from .jpg into .bmp format, if necessary
  if !$isfile($scriptdirfront.bmp) { jpg2bmp }

  ;load textures
  gl enable texture_2d
  gl bind_texture 13 | gl load_texture $scriptdirfront.bmp
  gl bind_texture 12 | gl load_texture $scriptdirright.bmp
  gl bind_texture 14 | gl load_texture $scriptdirback.bmp
  gl bind_texture 11 | gl load_texture $scriptdirleft.bmp
  gl bind_texture 15 | gl load_texture $scriptdirtop.bmp
  gl bind_texture 16 | gl load_texture $scriptdirbottom.bmp

  ;specify front plane
  var %p = 70, %n = $calc(-1 * %p)
  gl new_list 10000  
  gl tex_parameter texture_2d texture_min_filter nearest_mipmap_linear
  gl tex_parameter texture_2d texture_mag_filter nearest
  gl begin quads
  gl tex_coord 0 0 | gl vertex %n %n %p
  gl tex_coord 1 0 | gl vertex %p %n %p
  gl tex_coord 1 1 | gl vertex %p %p %p
  gl tex_coord 0 1 | gl vertex %n %p %p
  gl end
  gl end_list 10000

  ;initialization list
  gl new_list 11000
  gl clear
  gl load_identity
  gl end_list

  ;the skybox
  gl new_list 10003
  ;front
  gl bind_texture 12 | gl call_list 10000
  ;left
  gl bind_texture 14 | gl rotate 90 0 1 0 | gl call_list 10000
  ;back
  gl bind_texture 11 | gl rotate 90 0 1 0 | gl call_list 10000
  ;right
  gl bind_texture 13 | gl rotate 90 0 1 0 | gl call_list 10000
  ;top
  gl bind_texture 15
  gl rotate 270 0 0 1
  gl rotate 270 0 1 0
  gl call_list 10000
  ;bottom
  gl bind_texture 16
  gl rotate 180 1 0 0
  gl call_list 10000
  gl end_list 10003

  ;scene parameters
  set %gl_mouse_x $mouse.x
  set %gl_mouse_y $mouse.y
  set %gl_lat 0
  set %gl_long 0
  set %gl_x $calc($cos(%gl_lat) * $cos(%gl_long))
  set %gl_y $sin(%gl_lat)
  set %gl_z $calc($cos(%gl_lat) * $sin(%gl_long))
  set %gl_axis $iif($cos(%gl_lat) > 0,1,-1)

  ;we have all we need. start rendering
  .timergl -m 0 1 gl_paint attach $window(@test).hwnd
}

alias -l gl_paint {
  dll nLIGHTn gl $1-2
  dll nLIGHTn gl call_list 11000
  dll nLIGHTn gl look_at 0 0 0 %gl_x %gl_y %gl_z 0 %gl_axis 0
  dll nLIGHTn gl call_list 10003
  dll nLIGHTn gl swap_buffers
}

;when you close the window, the timer should stop
on ^*:CLOSE:@test: .timergl off

;we should react on mouse moves
menu @test {
  mouse: {
    if ($mouse.key & 1) {
      var %dx = $calc($mouse.x - %gl_mouse_x), %dy = $calc($mouse.y - %gl_mouse_y)
      dec %gl_lat $calc(%dy / 100)
      inc %gl_long $calc(%dx / $iif($cos(%gl_lat) > 0,100,-100))
      %gl_mouse_x = $mouse.x
      %gl_mouse_y = $mouse.y
      %gl_x = $calc($cos(%gl_lat) * $cos(%gl_long))
      %gl_y = $sin(%gl_lat)
      %gl_z = $calc($cos(%gl_lat) * $sin(%gl_long))
      %gl_axis = $iif($cos(%gl_lat) > 0,1,-1)
    }
  }
  sclick: { %gl_mouse_x = $mouse.x | %gl_mouse_y = $mouse.y }
}

;cleanup
on *:UNLOAD: {
  .remove $+(",$scriptdirfront.bmp,")
  .remove $+(",$scriptdirback.bmp,")
  .remove $+(",$scriptdirleft.bmp,")
  .remove $+(",$scriptdirright.bmp,")
  .remove $+(",$scriptdirtop.bmp,")
  .remove $+(",$scriptdirbottom.bmp,")
  unset %gl* 
}
