;this demo shows some keyboard control

;a temporary alias for simplifying nLIGHTn calls
alias gl { var %c = $dll(nLIGHTn,gl,$1-) | if (E_* iswm %c) echo -a $1- : %c | return %c }

;call this alias to see the demo
alias gldemo {
  clear

  ;first of all, we create a picture window (any HWND will do)
  window -p @test 0 0 512 256
  window -r @test
  titlebar @test - Arrow keys to move, space to fire

  ;attach a rendering device to the window and make it current
  gl attach $window(@test).hwnd
  gl auto_scale 1 45 1 250

  ;floor list
  gl new_list 10010
  gl begin lines
  var %i = -400 | while %i < 400 {
    gl vertex %i 0 0 | gl vertex %i 0 -400
    gl vertex -400 0 %i | gl vertex 400 0 %i
    inc %i 10
  }
  gl end  
  gl end_list 10010

  ;floor and ceiling
  gl new_list 10020
  gl color 0 1 0
  gl push_matrix
  gl translate 0 -10 0
  gl call_list 10010
  gl translate 0 20 0
  gl call_list 10010
  gl pop_matrix
  gl end_list 10020

  ;bullet (cylinder)
  gl new_list 10030
  gl push_matrix
  gl cylinder 1 1 5 20 20
  gl disk 0 1 20 20 0 glu_outside
  gl translate 0 0 -5 
  gl disk 0 1 20 20 0 glu_outside
  gl pop_matrix
  gl end_list 10030

  ;bullets
  gl new_list 10040
  gl color 1 1 0
  gl translate 7 -3 0
  gl call_list 10030
  gl translate -15 0 0
  gl call_list 10030
  gl load_identity
  gl end_list 10040

  ;model variables
  set %gl_x 0
  set %gl_y 0
  set %gl_dx 0
  set %gl_dy 0
  set %gl_firing 0
  set %gl_mis_z -300 
  set %gl_mis_x 0
  set %gl_mis_y 0

  ;we have all we need. start rendering
  .timergl -m 0 1 gl_paint $window(@test).hwnd
}

;this alias renders a single frame
alias gl_paint {
  dll nLIGHTn gl attach $1
  dll nLIGHTn gl clear
  dll nLIGHTn gl load_identity
  dll nLIGHTn gl translate $calc(%hl_x - %hl_mis_x) $calc(%hl_y - %gl_mis_y) %gl_mis_z
  dll nLIGHTn gl call_list 10040
  dll nLIGHTn gl load_identity
  dll nLIGHTn gl rotate $calc(%gl_dx * 4) 0 0 -1
  dll nLIGHTn gl rotate $calc(%gl_dy * 4) -1 0 0
  dll nLIGHTn gl translate $calc(%gl_x % 10) %gl_y $calc($ticks % 400 / 40)
  dll nLIGHTn gl call_list 10020
  dll nLIGHTn gl swap_buffers

  %gl_x = %gl_x + %gl_dx
  %gl_y = %gl_y + %gl_dy
  if %gl_y > 8 { %gl_y = 8 | %gl_dy = 0 }
  if %gl_y < -8 { %gl_y = -8 | %gl_dy = 0 }
  if %gl_dx > 0 { dec %gl_dx 0.015 }
  if %gl_dy > 0 { dec %gl_dy 0.015 }
  if %gl_dx < 0 { inc %gl_dx 0.015 }
  if %gl_dy < 0 { inc %gl_dy 0.015 }
  if (%gl_firing) {
    dec %gl_mis_z 10
    if %gl_mis_z < -250 { %gl_firing = 0 }
  }
}

;when you close the window, the timer should stop
on ^*:CLOSE:@test: .timergl off

;handle key presses
on *:KEYDOWN:@test:*: {
  if $keyval == 37 {
    inc %gl_dx 0.1
    if %gl_dx > 1 { %gl_dx = 1 }
  }
  elseif $keyval == 38 {
    dec %gl_dy 0.03
    if %gl_dy < -1 { %gl_dy = -1 }
  }
  elseif $keyval == 39 {
    dec %gl_dx 0.1
    if %gl_dx < -1 { %gl_dx = -1 }
  }
  elseif $keyval == 40 {
    inc %gl_dy 0.03
    if %gl_dy > 1 { %gl_dy = 1 }
  }
  elseif $keyval == 32 {
    if (!%gl_firing) {
      %gl_firing = 1
      %gl_mis_z = 0
      %gl_mis_x = %gl_x
      %gl_mis_y = %gl_y
    }
  }
}

;cleanup
on *:UNLOAD: unset %gl*
